/*
 *
 * Copyright (C) 2009,2010,2011 Halon Security <support@halon.se>
 *
 * This file is part of libdkim++.
 *
 * libdkim++ is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * libdkim++ is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with libdkim++.  If not, see <http://www.gnu.org/licenses/>.
 *
 */
#ifndef _DKIM_EXCEPTION_HPP_
#define _DKIM_EXCEPTION_HPP_

#include <cstring>
#include <cstdlib>
#include <memory>
#include <string>

#include "DllDeclarations.hpp"

//disabled throw declaration
#define declareThrow(...)

namespace DKIM
{
	class DLL_DECLARATION DkimException {
		char* whatString;
	public:
		DkimException(const DkimException& e) {
			*this = e;
		}
		DkimException& operator=(const DkimException& e) {
			whatString = strdup(e.whatString);
			return *this;
		}
		DkimException(const std::string& msg) {
			whatString = (char*)malloc(msg.size() + 1);
			memcpy(whatString, msg.c_str(), msg.size() + 1);
		}
		virtual ~DkimException() { free(whatString); }
		virtual const char* what() { return whatString; }
	};
	class DLL_DECLARATION PermanentError : public DkimException {
		public:
			PermanentError(const std::string& msg) : DkimException(msg) { }
	};
	class DLL_DECLARATION TemporaryError : public DkimException {
		public:
			TemporaryError(const std::string& msg) : DkimException(msg) { }
	};
}

#endif
